# or_project_inform

Operations Research project summer term 2020 RWTH Aachen, INFORM task group

The problem statement for this project was to explore and prototype Exact and Heuristic techniques to solve the 3d bin packing problem.
The sub problems are 1) Packing of item into boxes and 2) Packing of boxes to pallet.
Both the sub problem are 3d Bin packing problems with different requirements in terms of feasibility and ease of packing.

Problem Background: 3D bin packing is a classical NP-hard (Nondeterministic Polynomial-time hard) problem where a set N of 3D boxes is to be packed in a minimum number of containers (bins). 3D bin packing is used in many industrial applications; hence computer scientists are challenged in designing practical and efficient approaches for the problem.

## Getting Started

These instructions will get you a copy of the project up and running on your local machine for development and testing purposes. See deployment for notes on how to deploy the project locally.

### Prerequisites

What things you need to install the software and how to install them,

1. Python, version 3.7+, IDE (optional)
https://wiki.python.org/moin/BeginnersGuide/Download

2. Gurobi License (only necessary for using the split model)
https://www.gurobi.com/downloads/

### Installation and Usage 

A step by step series of examples that tell you how to get a development env running

1. Clone the git repository to your local device

2. Install the package. Either

2.1 python3 or_project_inform/src/inform-or/setup.py install

2.2 or install the wheel package located in or_project_inform/src/installation. Please refer to https://wheel.readthedocs.io/en/latest/user_guide.html#installing-wheels for more information.

2. Navigate to or_project_inform/src/inform-runner

3. Specify the approach that you would like to run with the input csv file ( the file must be structured like Generator.csv ) and output file where the solution can be stored
Eg. run_split_model.py ~PATH/TO/INPUT_CSV/input.csv ~PATH/TO/OUTPUT/output.csv 

4. Find the output files in ~/PATH/TO/OUTPUT/ORDER#/. For each processed order a new directory will be created to allow easy access to the generated instructions and visualizations.

The different approaches must be run individually, with different arguments. Run run_APPROACH_NAME.py -h or --help (e.g. run_split_model.py -h) for more information on how to use each individual approach.




## Acknowledgments
By

Akshay Ganesh (M.Sc. DDS)

Clinton Charles (M.Sc. DDS)

Janos Piddubnij (M.Sc. Data Science)

Kalyan Keesara (M.Sc. DDS)

Luca Koczula (M.Sc. Industrial Engineering)

Moritz Dederichs (M.Sc. Computer Science)

Tobias Wagner (M.Sc. Industrial Engineering)

Yordan Manolov (M.Sc. Computer Science)


Topic and supervision provided by RWTH Lehrstuhl für Operations Research and INFORM GmbH. 
All approaches based on scientific publications available at ~/Literature. 
